/************************************************/
/*						*/
/* L[{[h͂ꂽf[^t	*/
/* \vOł			*/
/* L[{[h́AJ2ɐڑĂ		*/
/*						*/
/************************************************/
/* CN[h					*/
/************************************************/

#include "3664f.h"
#include "machine.h"

/************************************************/
/* vg^Cv錾				*/
/************************************************/

extern void reset( void );

void main( void );
void wait( int msec );

void lcd_init( void );
void lcd_cls( void );
void lcd_ir_write( unsigned char data );
void lcd_dr_write( unsigned char data );
void lcd_clock( unsigned char data );
void lcd_print( char *data );
void lcd_locate( unsigned char x, unsigned char y );
void lcd_reg_print( unsigned char data );


void key_init( void );
unsigned char key_scan( unsigned char *key, unsigned char *shift );



#define LCD_CTLPORT_DR	PDR1
#define LCD_CTLPORT_CR	PCR1
#define LCD_E		0x01						/* bit0 */
#define LCD_RW		0x02						/* bit1 */
#define LCD_RS		0x04						/* bit2 */
#define LCD_DATPORT_DR	PDR5
#define LCD_DATPORT_CR	PCR5



const unsigned char disp_table[] = "0123456789ABCDEF";
/*					                                                                    	*/
const unsigned char str_table[]     = {0xb1,0xb6,0xbb,0xc0,0xc5,0xca,0xcf,0xd4,0xd7,0xdc,0xa0,0xa6,0xac,0x20,0x30,0x41};
const unsigned char strsize_table[] = {   5,   5,   5,   5,   5,   5,   5,   3,   5,   4,   6,   6,   5,  16,  17,  63};


/*str_tabléAL[ɑ΂Ċ蓖Ăt̕R[h̐擪*/
/*strsize_tabléAstr_tbl̃R[h炢̃R[hL[Ɋ蓖Ă邩̒l*/


/*  RlN^     */
/*        .   */
/*        .   */
/*      .  .   */
/*      .  .   */
/*  S1 S2 S3 S4  */


/************************************************/
/* 					*/
/************************************************/

void reset( void )
#pragma asm
	mov.l		#H'FF80,ER7	;X^bN|C^
#pragma endasm
{
	set_imask_ccr( 0 );
	_INITSCT();
	main();
	sleep();
}

/*************************************************
 C
*************************************************/
void main( void )
{


	unsigned char key_data, key_shift;

	int i = 0;
	int x = 0;
	unsigned char old_key = 0xff;
	unsigned char flag = 0;



	lcd_init();					/* LCD */
	key_init();



	while(1){

		lcd_locate( x, 0 );				/*J[\W*/

		/*ȂȂ܂ő҂*/
		while( key_scan( &key_data, &key_shift ) == 0 ){
		}

		/*܂ő҂*/
		while( key_scan( &key_data, &key_shift ) == 1 ){
		}

		switch( key_shift ){
			case 1:				/*S1L[*/
				if( x > 0 ){		/*J[\ʒu擪Eɂꍇ*/
					x--;		/*J[\ʒu*/
					i = 0;		/*L[̊蓖Ă*/
					old_key = 0xff;	/*L[̊蓖Ă*/
				}
				break;


			case 2:				/*S2EL[*/
				if( x < 15 ){		/*J[\ʒuI[荶ɂꍇ*/
					x++;		/*J[\ʒuE*/
					i = 0;		/*L[̊蓖Ă*/
					old_key = 0xff;	/*L[̊蓖Ă*/
				}
				break;


			case 0:				/*L[iVtgȊOj*/

				if( old_key == key_data ){			/*O̓L[Ɠ*/
					i++;					/*AR[h̃ItZbgCNg*/
					if( i == strsize_table[ key_data ] ){
						i = 0;				/*ItZbgɖ߂*/
					}
				}else{
					i = 0;					/*ItZbgɖ߂*/
				}

				lcd_dr_write( str_table[ key_data ] + i );	/*LCD\*/

				old_key = key_data;				/*̓L[ۑ*/
				break;


			default:
				break;
		}


	}
}





void key_init( void )
{
	*PCR1 = 0xff;
}


/****************************************************************/
/*	L[R[hɕϊ				*/
/*		̓L[̃R[hi[|C^		*/
/*		VtgL[̃R[hi[|C^		*/
/*	߂l	L[́@FP@ȂFO			*/
/****************************************************************/
unsigned char key_scan( unsigned char *key, unsigned char *shift )
{
	unsigned char x, y, bit_x, bit_y;

	*key = 0;						/*̓L[*/
	*shift = 0;						/*̓L[*/

	bit_y = 0x08;						/*|[gB3rbgڂ̓`FbN*/
	for( y = 0; y < 5; y++ ){				/*  */
		bit_x = 0x10;					/*|[g14rbgڂo*/
		for( x = 0; x < 4 ; x++ ){			/* s */

			*PDR1 = *PDR1 & 0x0f | bit_x;		/*o*/

			wait( 1 );

			if( y != 4 ){				/*VtgL[ȊO*/
				if( ( *PDRB & bit_y ) != 0 ){	/*͂Ȃ*/
					*key = x * 4 + y;
					return( 0 );
				}
			}
			else{					/*VtgL[̓*/
				if( ( *PDRB & bit_y ) != 0 ){	/*͂Ȃ*/
					*shift = x + 1;
					return( 0 );
				}
			}
			bit_x = bit_x * 2;			/*o̓rbgVtg*/
		}
		bit_y = bit_y * 2;			/*̓`FbNVtg*/
	}
	return( 1 );
}






/*************************************************
 t\
*************************************************/
void lcd_cls( void )
{
	lcd_ir_write( 0x01 );
	wait( 2 );
}

void lcd_locate( unsigned char x, unsigned char y )
{
	unsigned char i;
	i = y * 0x40 + x;
	i = i | 0x80;
	lcd_ir_write( i );
}

void lcd_print( char *data )
{
	while( *data != '\0' ){
		lcd_dr_write( *data );
		data++;
	}
}

void lcd_init( void )
{
	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR & ~LCD_E & ~LCD_RW & ~LCD_RS;
	*LCD_DATPORT_DR = 0x00;
	*LCD_CTLPORT_CR = *LCD_CTLPORT_DR | LCD_E | LCD_RW | LCD_RS;
	*LCD_DATPORT_CR = 0xff;

	wait( 20 );
	lcd_clock( 3 );							/* function set */
	wait( 5 );
	lcd_clock( 3 );							/* function set */
	lcd_clock( 3 );							/* function set */
	lcd_clock( 2 );							/* function set */

	lcd_ir_write( 0x28 );						/* function set */
	lcd_ir_write( 0x08 );						/* on/off control */
	lcd_cls();
	lcd_ir_write( 0x06 );						/* entry mode set */
	lcd_ir_write( 0x0d );						/* on/off control */
}

void lcd_ir_write( unsigned char data )
{
	unsigned char i;

	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR & ~LCD_RS;
	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR & ~LCD_RW;		/* write */

	i = ( data & 0xf0 ) >> 4;
	lcd_clock( i );

	i = data & 0xf;
	lcd_clock( i );
}

void lcd_dr_write( unsigned char data )
{
	unsigned char i;

	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR | LCD_RS;
	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR & ~LCD_RW;		/* write */

	i = ( data & 0xf0 ) >> 4;
	lcd_clock( i );

	i = data & 0xf;
	lcd_clock( i );
}

void lcd_clock( unsigned char data )
{
	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR | LCD_E;
	*LCD_DATPORT_DR = ( *LCD_DATPORT_DR & 0xf0 ) | ( data & 0x0f );
	wait( 1 );
	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR & ~LCD_E;
	wait( 1 );
	*LCD_DATPORT_DR = ( *LCD_CTLPORT_DR & 0xf0 );
}


void lcd_reg_print( unsigned char data )
{
/*	const unsigned char disp_table[] = "0123456789ABCDEF";*/

	lcd_dr_write( disp_table[ ( data & 0xf0 ) >> 4 ] );
	lcd_dr_write( disp_table[ ( data & 0xf ) ] );
}




/*************************************************
 ^C}[
*************************************************/
void wait( int msec )
{
	long i;
	for( i=0; i<1000 * ( long )msec; i++ ){
	}
}



